/*=============================================
재정패널 만들기 : smart_nastab_v2 명령어 
가구데이터에서 가구원 변수 가져오기 
2021.02.15 12차 공식 update
==============================================*/
	program define smart_nastab_m_v2, rclass 
	version 14.0 
	clear 
	set more off
	syntax newvarlist(min=1 max=100 numeric generate) , [wd(string) wide website(string)] wave(string)   
	qui cd "`wd'" 
	local v1 "`wave'" 
	return scalar NW=wordcount("`v1'") 
	local NV=wordcount("`varlist'")
	return scalar NV=`NV'	
	
	qui foreach v of local v1   {
	
				if "`website'"=="" {
							use NaSTaB`v'H, clear							
						}
							
				else {	
					use `website'/NaSTaB`v'H, clear							
				}	
													
					keep hid`v' w`v'byr01-w`v'jpo09 hpid01- hpid09					
					reshape long w`v'byr0@ w`v'gen0@ w`v'mar0@ w`v'rel0@  ///
					w`v'edu0@ w`v'grd0@ w`v'job0@ w`v'jpo0@ hpid0@ , i(hid`v') j(num)
					format hpid0 %15.0g
					ren w*0 w*
					ren hpid0 pid
					drop if pid==.
					drop num							
	
	        forvalues i=1/`NV' {			
			
						* 1번
						if "``i''"=="page" {
								gen   ``i''=w`v'byr
								recode ``i'' (-1 -9=.)
								replace ``i''=2007-``i'' if "`v'"=="01"
								replace ``i''=2008-``i'' if "`v'"=="02"
								replace ``i''=2009-``i'' if "`v'"=="03"
								replace ``i''=2010-``i'' if "`v'"=="04"
								replace ``i''=2011-``i'' if "`v'"=="05"
								replace ``i''=2012-``i'' if "`v'"=="06"
								replace ``i''=2013-``i'' if "`v'"=="07"		
								replace ``i''=2014-``i'' if "`v'"=="08"
								replace ``i''=2015-``i'' if "`v'"=="09"	
								replace ``i''=2016-``i'' if "`v'"=="10"
								replace ``i''=2017-``i'' if "`v'"=="11"
								replace ``i''=2018-``i'' if "`v'"=="12"
								recode ``i'' (min/-1=0)
								label var ``i'' "[가구원] 연령 " 
						}
						
						* 2번 
						else if "``i''"=="pgen" {
								gen   ``i''=w`v'gen
								recode ``i'' (-9=.) 
								label var ``i'' "[가구원] 성별 " 
								}
								
						* 3번 
						/*
						else if "``i''"=="가구원혼인" {
								gen   ``i''=w`v'mar
									if "`v'"=="04"| "`v'"=="05"| "`v'"=="06"| "`v'"=="07" | "`v'"=="08"  {
									recode ``i'' (1/2=1) (3=2)
									}						
								recode ``i'' (-9=.) 
								label var ``i'' "가구원 혼인상태(배우자있음=1,배우자없음/미혼=2)  " 
						}
						*/
						* 4번 
						else if "``i''"=="prel" {
							gen   ``i''=w`v'rel
							recode ``i'' (-9=.) 
							label var ``i'' "[가구원] 가구주와의 관계코드  " 
						}
						
						* 5번 
						else if "``i''"=="pedu" {
							tempvar aa
							gen `aa'=w`v'grd
							gen ``i''=w`v'edu
							recode `aa' ``i'' (-9=.)
							
							recode ``i'' (1/3=1) (4=2) (5/max=3) 
							replace ``i''=1 if `aa'~=2 & ``i''==2 
							replace ``i''=2 if `aa'~=2 & ``i''==3 
												
							label var ``i'' "[가구원] 최종 교육수준(1=중졸이하, 2=고졸, 3=전문대졸이상)" 
						}
						
						* 6번 
						else if "``i''"=="aa200" {
							gen   ``i''=w`v'job
							recode ``i'' (-9 15=.)	(1/11=1) (12=2) (13=3) (14=4) 
							label var ``i'' "[경활상태] (현재, 조사년도 5월 1일 기준) 취업상태(1=취업 2=전업주부 3=무직 4=학생)" 
						}
						
						* 7번 
						else if "``i''"=="aa005" {
							gen   ``i''=w`v'jpo
							recode ``i'' (-9=.)	(1=1) (2/3=2) (4/5=3) (6=4) 
							label var ``i'' "[경활상태] (현재, 조사년도 5월 1일 기준) 종사상지위(1=상용직 2=임시/일용직 3=자영업 4=무급가족종사자 )  " 
						}
						
						/*==============================================================*/
																													
						* error message 
						else {
							di as err "``i'' NOT appear on the new variable list" 
						}
				
		}   // the end of forvalues loop
												
			gen wave="`v'"
			gen wave1=real(wave)
			drop wave
			rename wave1 wave 
			label var wave "서베이차수" 
			gen year=wave+2006
			label var year "조사년도"
			rename hid`v' hhid
			drop if hhid==. 
			label var hhid "가구id" 
			drop if pid==. 
			label var pid "가구원id"
			keep hhid pid wave year `varlist'
			ren * p_*
			ren (p_hhid p_pid p_year p_wave) (hhid pid year wave)
	
	tempfile koweps`v'p_1 
	save "`koweps`v'p_1'", replace 
	}
	
	
	qui if r(NW)==1 {
	  foreach v of local v1   {
	  use "`koweps`v'p_1'", clear
	  tsset pid wave 
	  capture drop __*
	  compress
	  format hhid pid %15.0g
	  order hhid pid wave year 
	  drop if pid==.
	  save nastab_m_final, replace 
	  }
	}
	
	qui else {
	 local v2=substr("`v1'", 1,2) 
	 use "`koweps`v2'p_1'", clear 
	 local v3=substr("`v1'",4, .)
	 	 
		 foreach v of local v3  {
		 append using "`koweps`v'p_1'" 
		 }
			order hhid pid wave
			tsset pid wave 	
			aorder 
			order hhid pid wave year 
			format hhid pid %15.0g
			capture drop __*
			compress
			drop if pid==.
			save nastab_m_final, replace		   
		}
	
	
	if "`wide'"=="wide" {
		capture drop year 
		reshape wide hhid p_* , i(pid) j(wave)
		aorder 
		order pid
		capture drop __*
		compress
		save nastab_m_final_`wide', replace 
	}		 
		 
	end 
	 
 