/*=============================================
재정패널 만들기 : smart_nastab_v2 명령어 
2021.02.15 12차 공식 update 
==============================================*/
	program define smart_nastab_p_v2, rclass 
	version 14.0 
	clear 
	set more off
	syntax newvarlist(min=1 max=100 numeric generate) , [wd(string) wide website(string)] wave(string)   
	qui cd "`wd'" 
	local v1 "`wave'" 
	return scalar NW=wordcount("`v1'") 
	local NV=wordcount("`varlist'")
	return scalar NV=`NV'
				
				
	qui foreach v of local v1   {						
		
				if "`website'"=="" {					
					use NaSTaB`v'P, clear					
				}
				else {						
					use `website'/NaSTaB`v'P, clear	
				}
					
	        forvalues i=1/`NV' {			
						/*===============================*/
						* 소득변수 먼저 생성하기 
						/*===============================*/
						/*
						
						qui ds
						foreach vvv in p`v'ba005 p`v'ba008 p`v'ba016 p`v'ba018 p`v'ba020 ///
								               p`v'ba022 p`v'ba024 p`v'ba128 p`v'ba130 ///
											   p`v'ba052 p`v'ba054 p`v'ba056 ///
								               p`v'ba058 p`v'ba060 p`v'ba062 p`v'ba064 ///
											   p`v'ba066 p`v'ba068 p`v'ba070 p`v'ba072 ///
											   p`v'bb002 p`v'bb006 p`v'bb008  p`v'bb018 ///
											   p`v'bb030 {
											   if regexm(r(varlist),"`vvv'")==0 {
												  gen `vvv'=.
											   }															
								}								
						egen p_`v'_inc_ba1=rowtotal(p`v'ba005 p`v'ba008)
						egen p_`v'_inc_ba2=rowtotal(p`v'ba016 p`v'ba018 p`v'ba020 ///
								                            p`v'ba022 p`v'ba024 p`v'ba128 p`v'ba130)	
						egen p_`v'_inc_ba3=rowtotal(p`v'ba032 p`v'ba035 p`v'ba038 ///
								                            p`v'ba022 p`v'ba024 p`v'ba128 p`v'ba130)															
						* 퇴직연금 
						egen p_`v'_inc_ba4=rowtotal(p`v'ba052 p`v'ba054 p`v'ba056 ///
								                            p`v'ba058 p`v'ba060 p`v'ba062 p`v'ba064 ///
															p`v'ba066 p`v'ba068 p`v'ba070 p`v'ba072)
						* 근로소득 
						egen p_`v'_inc_bb1=rowtotal(p`v'bb002 )
						* 사업소득 
						egen p_`v'_inc_bb2=rowtotal(p`v'bb006 )
						* 부동산
						egen p_`v'_inc_bb3=rowtotal(p`v'bb008 )
						* 이자  
						egen p_`v'_inc_bb4=rowtotal(p`v'bb018 )
						* 기타  
						egen p_`v'_inc_bb5=rowtotal(p`v'bb030 )
						* 합계 
						egen p_`v'_inc_all=rowtotal(p_`v'_inc_ba1 p_`v'_inc_ba2 p_`v'_inc_ba3 p_`v'_inc_ba4 ///
						                            p_`v'_inc_bb1 p_`v'_inc_bb2 p_`v'_inc_bb3 p_`v'_inc_bb4)
						*/
						/*==========================================================================================*/				
						
						* 1번
						if "``i''"=="a13" {
							gen   ``i''=ps`v'a13
							recode ``i'' (-9=.)
							label var ``i'' "[가구원] 소득공제 근거자료 제출여부(1=근로, 2=종합, 3=근로/종합 4=미제출) " 
						}
						
						* 2번 
						else if "``i''"=="aa100" {
							gen   ``i''=ps`v'a02
							recode ``i'' (-9=.) 
							label var ``i'' "[경활상태] 작년 한 해 소득 유무(1=있다 2=없다)  " 
						}
						
						* 3번 
						else if "``i''"=="aa001" {
							if "`v'"=="01" {
								gen ``i''=.
							} 
							else {
								gen   ``i''=p`v'aa001
								recode ``i'' (-9=.) 
							}
							
							label var ``i'' "[경활상태] (현재, 조사년도 5월 1일 기준) 평소 소득활동여부(1=있다 2=없다) " 
						}
						* 4번 
						else if "``i''"=="aa002" {
								if "`v'"=="01" {
									gen ``i''=.
								} 
								else {
									gen   ``i''=p`v'aa002
									recode ``i'' (-9=.) 
								}
								label var ``i'' "[경활상태] (현재, 조사년도 5월 1일 기준) 취업형태(1=임금 2=비임금)" 
						}
						* 5번 
						else if "``i''"=="aa006" {
								if "`v'"=="01" {
									gen ``i''=.
								} 
								else {
									gen   ``i''=p`v'aa006
									recode ``i'' (-9=.) 
								}
								label var ``i'' "[경활상태] (현재, 조사년도 5월 1일 기준) 근무시간형태(1=전일제 2=시간제)  " 
						}
						
						* 6번 
						else if "``i''"=="inc_ba1" {															
								gen   ``i''=p_`v'_inc_ba1
								label var ``i'' "[소득] 연간 사회보험금 수령액(단위: 만원)" 
						}
						
						* 7번 
						else if "``i''"=="inc_ba2" {					       
								gen   ``i''=p_`v'_inc_ba2
								label var ``i'' "[소득] 연간 민간보험금 수령액(단위: 만원) " 
						}
						* 9번 
						else if "``i''"=="inc_ba3" {															
								gen   ``i''=p_`v'_inc_ba3
								label var ``i'' "[소득] 연간 정부지원현금소득액(단위: 만원) " 
						}
						/*
						* 9-1번 
						else if "``i''"=="inc_ba4" {															
								gen   ``i''=p_`v'_inc_ba4
								label var ``i'' "[소득] 특수직 퇴직연금/퇴직일시금/개인연금 (단위: 만원) " 
						}
						*/
						
						* 10번 
						else if "``i''"=="inc_bb1" {
								gen   ``i''=p_`v'_inc_bb1
								label var ``i'' "[소득] 연간 근로소득(단위: 만원) " 
						}
						
						* 11번 
						else if "``i''"=="inc_bb2" {
								gen   ``i''=p_`v'_inc_bb2
								label var ``i'' "[소득] 연간 순사업소득(단위: 만원) " 
						}
						
						* 12번 
						else if "``i''"=="inc_bb3" {
								gen   ``i''=p_`v'_inc_bb3
								label var ``i'' "[소득] 연간 부동산 임대소득(단위: 만원)" 
						}
						
						* 13번 
						else if "``i''"=="inc_bb4" {
								gen   ``i''=p_`v'_inc_bb4
								label var ``i'' "[소득] 연간 이자, 배당, 양도소득(단위: 만원)" 
						}
						* 14번 
						else if "``i''"=="inc_bb5" {
								gen   ``i''=p_`v'_inc_bb5
								label var ``i'' "[소득] 연간 기타소득(단위: 만원) " 
						}
						
						* 15번 
						else if "``i''"=="pinc" {
								gen   ``i''=p_`v'_inc_all
								label var ``i'' " [소득] 가구원별 연간소득 총액(단위: 만원) " 
						}									
						
						* 19번
						else if "``i''"=="bc012" {
							tempvar aa
							gen `aa'=p`v'bc007
							gen   ``i''=p`v'bc012
							recode ``i'' (-9=.) 
							replace ``i''=0 if `aa'==2
							label var ``i'' "[지출] 연간 국민연금보험료 납부금액(단위: 만원) " 
						}	
						* 20번 
						else if "``i''"=="bc019" {
						tempvar aa
							gen `aa'=p`v'bc007
							gen   ``i''=p`v'bc019
							recode ``i'' (-9=.) 
								if "`v'"=="03"| "`v'"=="04"|"`v'"=="05"| "`v'"=="06"|"`v'"=="07"  |"`v'"=="08"|"`v'"=="09"|"`v'"=="10"|"`v'"=="11"|"`v'"=="12" {
									replace ``i''=12*``i''						
								}
							replace ``i''=0 if `aa'==2
							label var ``i'' "[지출] 연간 특수직연금보험료 납부금액(단위: 만원) " 
						}
						* 21번
						else if "``i''"=="bc026" {
							tempvar aa
							gen `aa'=p`v'bc023
							gen   ``i''=p`v'bc026
							recode ``i'' (-9=.) 
							replace ``i''=0 if `aa'==2
							label var ``i'' "[지출] 연간 건강보험료 납부금액(단위: 만원) " 
						}	
						
						* 22번 고용보험
						else if "``i''"=="bc032" {
							tempvar aa
							gen `aa'=p`v'bc030
							gen   ``i''=p`v'bc032
							recode ``i'' (-9=.) 
							replace ``i''=0 if `aa'==2
							label var ``i'' "[지출] 연간 고용보험료 납부금액(단위: 만원)) " 
						}
						
						* 24번 : 민간보험 연금 총액 
						else if "``i''"=="bc100" {
								tempvar aa bb cc dd ee ff 
								gen  `aa'=p`v'bc044
								gen  `bb'=p`v'bc046
								gen  `cc'=p`v'bc048
								gen  `dd'=p`v'bc050
								gen  `ee'=p`v'bc052
								gen  `ff'=p`v'bc054
								
								mvdecode p`v'bc045 p`v'bc047 p`v'bc049 p`v'bc051 p`v'bc053 p`v'bc055 , mv(-9=.)
								egen ``i''=rowtotal(p`v'bc045 p`v'bc047 p`v'bc049 p`v'bc051 p`v'bc053 p`v'bc055) , miss
								replace ``i''=0 if `aa'==2 & `bb'==2 & `cc'==2 & `dd'==2 & `ee'==2 & `ff'==2 	
														
								label var ``i'' "[지출] 연간 민간보험/연금 납부금액(단위: 만원) " 
						}
																
						/*================================================*/
						else if "``i''"=="pcw" {	
							gen ``i''=p`v'cwt
							label var ``i'' "[가구원] 횡단면 가중치"
						}
						
						else if "``i''"=="plw" {	
						    if "`v'"=="01" {
							gen ``i''=.
							}
							else {
							gen ``i''=p`v'lwt
							}
							label var ``i'' "[가구원] 종단면 가중치"
						}
																							
						* error message 
						else {
						di as err "``i'' is not supposed to be on the new variable list" 
						}
				
		}   // the end of forvalues loop
												
			gen wave="`v'"
			gen wave1=real(wave)
			drop wave
			rename wave1 wave 
			label var wave "서베이차수" 
			gen year=wave+2006
			label var year "조사년도"
			rename hid`v' hhid
			drop if hhid==. 
			label var hhid "가구id" 
			rename pid`v' pid
			drop if pid==. 
			label var pid "가구원id"
			keep hhid pid wave year `varlist'
			ren * p_*
			ren (p_hhid p_pid p_year p_wave) (hhid pid year wave)
	
	tempfile koweps`v'p_1 
	save "`koweps`v'p_1'", replace 
	}
	
	
	qui if r(NW)==1 {
	  foreach v of local v1   {
	  use "`koweps`v'p_1'", clear
	  tsset pid wave 
	  capture drop __*
	  compress
	  format hhid pid %15.0g
	  order hhid pid wave year 
	  drop if pid==.
	  save nastab_p_final, replace 
	  }
	}
	
	qui else {
	 local v2=substr("`v1'", 1,2) 
	 use "`koweps`v2'p_1'", clear 
	 local v3=substr("`v1'",4, .)
	 	 
		 foreach v of local v3  {
		 append using "`koweps`v'p_1'" 
		 }
			order hhid pid wave
			tsset pid wave 	
			aorder 
			order hhid pid wave year 
			format hhid pid %15.0g
			capture drop __*
			compress
			drop if pid==.
			save nastab_p_final, replace		   
		}
	
	
	if "`wide'"=="wide" {
		capture drop year 
		reshape wide hhid p_* , i(pid) j(wave)
		aorder 
		order pid
		capture drop __*
		compress
		save nastab_p_final_`wide', replace 
	}		 
		 
	end 
	 
 