/*=============================================
재정패널 만들기 : smart_nastab_v2 명령어 
2019-05-25: 11차 데이터 업데이트  
==============================================*/
	program define smart_nastab_v2 , rclass 
	version 14.0 
	clear 
	set more off
    syntax newvarlist(min=1 max=200 numeric generate) , [wd(string) wide website(string) save(string) add_h(string) add_p(string)] wave(string) 
	
	local plist1 ""
	local mlist1 ""
	local hlist1 ""
	
	#delimit ; 
	local plist
	"a13
	aa100
	aa001	
	aa002	
	aa006
	bc032
	bc026
	bc012
	bc019
	bc100
	pinc
	inc_ba1
	inc_ba2
	inc_ba3
	inc_bb1
	inc_bb2
	inc_bb3
	inc_bb4
	inc_bb5
	pcw
	plw" ;
	
	local hlist
	"hgen
	hage
	hedu
	hjob
	hjpo
	hmar
	fnum
	hinc
	hexp
	ba001
	ba002
	ba007
	ba003
	ba700
	hsize
	bb002
	bb003
	bb005
	bb006
	bb007
	bb101
	bb008
	exp_bb
	exp_cb
	exp_cc
	exp_cd
	exp_ce
	exp_cf
	exp_cg
	exp_ch
	exp_co
	exp_cp
	exp_cr
	exp_ci
	exp_cj 
	exp_ck
	exp_cl
	exp_cm
	exp_cn
	exp_cq
	exp_cs
	exp_ct
	exp_cu
	asset_fa
	asset_fb
	debt_fc
	b10
	hcw
	hlw" ;
		

	#delimit cr	
	local mlist="pgen page prel pedu aa200 aa005"
	
	foreach v in `varlist'  {
	  local vv1=regexm("`hlist'","`v'")
	  local vv2=2*regexm("`plist'","`v'")
	  local vv3=3*regexm("`mlist'","`v'")
	  	  
	   qui if `vv1'==1   {	    	   
	   local hlist1 `hlist1' `v'    // 띄어쓰기 아주 중요함 
	   }
	   
	   qui else if `vv2'==2 { 
	   local plist1 `plist1' `v'   // 띄어쓰기 아주 중요함   
	   }
	   
	   qui else if `vv3'==3 { 
	   local mlist1 `mlist1' `v'   // 띄어쓰기 아주 중요함   
	   }	    	   
	}
	
	local Nhlist=wordcount("`hlist1'")
	local Nplist=wordcount("`plist1'") 
	local Nmlist=wordcount("`mlist1'")
	
	/*=================================================================================*/
	* add_h와 add_p에 변수가 있는 경우 
	if "`add_h'"~="" {
	    if "`website'"=="" {
			smart_nastab_add_h_v2 `add_h' , wd(`wd') wave(`wave') 
	    }
		else {
			smart_nastab_add_h_v2 `add_h' , wd(`wd') wave(`wave') website(`website') 
		}	
	}
	
	if "`add_p'"~="" {
		if "`website'"=="" {
			smart_nastab_add_p_v2 `add_p' , wd(`wd') wave(`wave') 
	    }
		else {
			smart_nastab_add_p_v2 `add_p' , wd(`wd') wave(`wave') website(`website') 
		}
	
	}
	/*=================================================================================*/
		
	* Case 1 : 1 0 0
	if `Nhlist'~=0 & `Nplist'==0 & `Nmlist'==0 {
			
				if "`website'"=="" {
				smart_nastab_h_v2 `hlist1' , wd(`wd') wave(`wave') 
				}
				else {
				smart_nastab_h_v2 `hlist1' , wd(`wd') wave(`wave') website(`website') 
				}	
				save nastab_final, replace
				
				if "`wide'"=="wide" {
					if "`website'"=="" {
					smart_nastab_h_v2 `hlist1' , wd(`wd') wave(`wave') wide 
					}
					else {
					smart_nastab_h_v2 `hlist1' , wd(`wd') wave(`wave') wide website(`website') 
					}	
		  		    save nastab_final_`wide', replace 
				}
							
	}

	* Case 2: 0 1 0
	else if `Nhlist'==0 & `Nplist'~=0 & `Nmlist'==0 {			
			
			if "`website'"=="" {
				smart_nastab_p_v2 `plist1' , wd(`wd') wave(`wave') 
				}
				else {
				smart_nastab_p_v2 `plist1' , wd(`wd') wave(`wave') website(`website') 
				}	
				save nastab_final, replace
				
				
				if "`wide'"=="wide" {
					if "`website'"=="" {
					smart_nastab_p_v2 `plist1' , wd(`wd') wave(`wave') wide 
					}
					else {
					smart_nastab_p_v2 `plist1' , wd(`wd') wave(`wave') wide website(`website') 
					}	
		  		    save nastab_final_`wide', replace 
				}				
	}
	
	* Case 3: 0 0 1
	else if `Nhlist'==0 & `Nplist'==0 & `Nmlist'~=0 {			
			
			if "`website'"=="" {
				smart_nastab_m_v2 `mlist1' , wd(`wd') wave(`wave') 
				}
				else {
				smart_nastab_m_v2 `mlist1' , wd(`wd') wave(`wave') website(`website') 
				}
				* ren m_* p_*
				save nastab_final, replace
				
				if "`wide'"=="wide" {
					if "`website'"=="" {
					smart_nastab_m_v2 `mlist1' , wd(`wd') wave(`wave') wide 
					}
					else {
					smart_nastab_m_v2 `mlist1' , wd(`wd') wave(`wave') wide website(`website') 
					}
					* ren m_* p_*
		  		    save nastab_final_`wide', replace 
				}		
				
	}
		
	* Case 4: 1 1 0 
	else if  `Nhlist'~=0 & `Nplist'~=0 & `Nmlist'==0 {
	
				if "`website'"=="" {
				smart_nastab_h_v2 `hlist1' , wd(`wd') wave(`wave') 
				smart_nastab_p_v2 `plist1' , wd(`wd') wave(`wave') 
				}
				else {
				smart_nastab_h_v2 `hlist1' , wd(`wd') wave(`wave') website(`website') 
				smart_nastab_p_v2 `plist1' , wd(`wd') wave(`wave') website(`website') 
				}				
	
				use nastab_h_final,clear 
				merge 1:m hhid wave using nastab_p_final, nogen
				aorder
				order hhid pid wave year 
				sort hhid pid wave
				save nastab_final, replace 
				
				if "`wide'"=="wide" {
				capture drop year 
				drop if pid==.
				reshape wide hhid h_* p_*, i(pid) j(wave)
				aorder 
				order pid hhid*
		        save nastab_final_`wide', replace 
				}			
				
	}
	
	* Case 5: 1 0 1 
		else if  `Nhlist'~=0 & `Nplist'==0 & `Nmlist'~=0 {
	
				if "`website'"=="" {
				smart_nastab_h_v2 `hlist1' , wd(`wd') wave(`wave') 
				smart_nastab_m_v2 `mlist1' , wd(`wd') wave(`wave') 
				}
				else {
				smart_nastab_h_v2 `hlist1' , wd(`wd') wave(`wave') website(`website') 
				smart_nastab_m_v2 `mlist1' , wd(`wd') wave(`wave') website(`website') 
				}				
	
				use nastab_h_final,clear 
				merge 1:m hhid wave using nastab_m_final, nogen
				aorder
				order hhid pid wave year
				sort hhid pid wave
				* ren m_* p_*
				save nastab_final, replace 
				
				if "`wide'"=="wide" {
				capture drop year 
				reshape wide hhid h_* p_*, i(pid) j(wave)
				aorder 
				order pid hhid*
				save nastab_final_`wide', replace 
				}	
				
	}
		
	* Case 6: 0 1 1 
		else if  `Nhlist'==0 & `Nplist'~=0 & `Nmlist'~=0 {
	
				if "`website'"=="" {
				smart_nastab_p_v2 `plist1' , wd(`wd') wave(`wave') 
				smart_nastab_m_v2 `mlist1' , wd(`wd') wave(`wave') 
				}
				else {
				smart_nastab_p_v2 `plist1' , wd(`wd') wave(`wave') website(`website') 
				smart_nastab_m_v2 `mlist1' , wd(`wd') wave(`wave') website(`website') 
				}				
	
				use nastab_p_final,clear 
				merge 1:1 pid wave using nastab_m_final, nogen
				aorder
				order hhid pid wave year 
				sort hhid pid wave
				* ren m_* p_*
				save nastab_final, replace
				
				if "`wide'"=="wide" {
					if "`website'"=="" {
					smart_nastab_p_v2 `plist1' , wd(`wd') wave(`wave') wide 
					smart_nastab_m_v2 `mlist1' , wd(`wd') wave(`wave') wide 
					}
					else {
					smart_nastab_p_v2 `plist1' , wd(`wd') wave(`wave') wide website(`website') 
					smart_nastab_m_v2 `mlist1' , wd(`wd') wave(`wave') wide website(`website') 
					}
					use nastab_p_final_wide, clear
					merge 1:1 pid wave using nastab_m_final_wide, nogen 
					aorder
					order pid hhid* wave
					sort pid wave
					save nastab_final_`wide', replace 
				}								
	}
	
		* Case 7: 1 1 1 
		else if  `Nhlist'~=0 & `Nplist'~=0 & `Nmlist'~=0 {
	
				if "`website'"=="" {
				smart_nastab_h_v2 `hlist1' , wd(`wd') wave(`wave')
				smart_nastab_p_v2 `plist1' , wd(`wd') wave(`wave') 
				smart_nastab_m_v2 `mlist1' , wd(`wd') wave(`wave') 
				}
				else {
				smart_nastab_h_v2 `hlist1' , wd(`wd') wave(`wave') website(`website') 
				smart_nastab_p_v2 `plist1' , wd(`wd') wave(`wave') website(`website') 
				smart_nastab_m_v2 `mlist1' , wd(`wd') wave(`wave') website(`website') 
				}				
	
				use nastab_h_final,clear 
				merge 1:m hhid wave using nastab_m_final, nogen
				drop if pid==.
				merge 1:1 pid wave using nastab_p_final, nogen  //  p가 먼저 m이 먼저 매우 중요함 
				aorder
				order hhid pid wave year 
				sort hhid pid wave
				* ren m_* p_*
				save nastab_final, replace 
				
				if "`wide'"=="wide" {
				capture drop year 
				reshape wide hhid h_* p_* , i(pid) j(wave)
				aorder 
				order pid hhid*
				save nastab_final_`wide', replace 	
				}					
	}	
	
	* 기본 파일과 add 파일의 merge 
	* case 1: 기본 파일에 h만 있는 경우 
	        use nastab_final, clear 
			qui ds
			local aaa1=regexm(r(varlist), "hhid")
			local aaa2=regexm(r(varlist), "pid")
			local aaa3=`aaa1'+`aaa2'
			if `aaa3'==1 {
				local mastertype "h"
			}
			else if `aaa3'==2 {
				local mastertype "p"
			}
			
			if "`mastertype'"=="h" {
					* case 1-1 : add_h만 있는 경우 
					if "`add_h'"~=""& "`add_p'"=="" {
							merge 1:1 hhid wave using nastab_add_h, nogen 
							order hhid wave 
							sort hhid wave
							drop if hhid==.
							save nastab_final_add, replace
					}
					
					* case 1-2: add_p만 있는 경우 
					if "`add_h'"==""& "`add_p'"~="" {			        
							merge 1:1 pid wave using nastab_add_p, nogen 
							order hhid pid wave 
							sort pid wave
							drop if pid==.
							save nastab_final_add, replace
					}
					
					* case 1-3: add_p와 add_h가 모두 있는 경우 
					if "`add_h'"~=""& "`add_p'"~="" {							
							merge 1:1 hhid wave using nastab_add_h, nogen 
							merge 1:m hhid wave using nastab_add_p, nogen 
							order hhid pid wave 
							sort pid wave
							drop if pid==.
							save nastab_final_add, replace
					}
					
					if "`add_h'"==""& "`add_p'"=="" {
						save nastab_final_add , replace 
					}
	          }  // case 1 
	
	* case 2: 기본파일에 p(또는 h and p)만 있는 경우 
	         if "`mastertype'"=="p" {
					* case 1-1 : add_h만 있는 경우 
					if "`add_h'"~=""& "`add_p'"=="" {
					        drop if pid==.
							merge m:1 hhid wave using nastab_add_h, nogen 
							order hhid pid wave 
							sort  pid wave
							drop if hhid==.
							save nastab_final_add, replace
					}
					
					* case 1-2: add_p만 있는 경우 
					if "`add_h'"==""& "`add_p'"~="" {	
							drop if pid==.
							merge 1:1 pid wave using nastab_add_p, nogen 
							order hhid pid wave 
							sort pid wave
							drop if pid==.
							save nastab_final_add, replace
					}
					
					* case 1-3: add_p와 add_h가 모두 있는 경우 
					if "`add_h'"~=""& "`add_p'"~="" {		
							drop if pid==.
							merge 1:1 pid wave using nastab_add_p, nogen
							merge m:1 hhid wave using nastab_add_h, nogen 
							 
							order hhid pid wave 
							sort pid wave
							drop if pid==.
							save nastab_final_add, replace
					}
					if "`add_h'"==""& "`add_p'"=="" {
						save nastab_final_add , replace 
					}
	
	
			}  // case 2 
			
	
			
	if "`save'"~=""  {
		use nastab_final_add, clear
		save `save', replace 
		capture erase nastab_final_add.dta
    }

	* 일단 wide 옵션은 제외한다. 
	
capture {
	erase nastab_h_final.dta 
	erase nastab_p_final.dta 
	erase nastab_m_final.dta 
	erase nastab_h_final_wide.dta 
	erase nastab_p_final_wide.dta 
	erase nastab_m_final_wide.dta 		
	erase nastab_add_h.dta
	erase nastab_add_p.dta 
	erase nastab_final.dta
}
  
	
	/*
	local add_h "hba002 hba006 hba003"
	local add_p "psa13 paa001 pbc033"
	*/
	
	local add_h_list "hba001 hba002 hba007 hba003 hba700 hbb002 hbb003 hbb005 hbb006 hbb007 hbb101 hbb008 hsb10"
	local add_p_list "psa13 paa001 paa002 paa006 pbc032 pbc026 pbc012 pbc019 pbc100"
	
	di "==========================================================================================================================="
	foreach v in `add_h_list' {
			if regexm("`add_h'","`v'") {
				di "Note) add_h 옵션에서 선택한 `v'는 가구레벨에 이미 설정되어 있음. 굳이 중복하여 add_h 옵션에서 선택하실 필요 없습니다."
			}
	}
	
	foreach v in `add_p_list' {
			if regexm("`add_p'","`v'") {
				di "Note) add_p 옵션에서 선택한 `v'는 가구원레벨에 이미 설정되어 있음. 굳이 중복하여 add_p 옵션에서 선택하실 필요 없습니다."
			}
	}
	di "=========================================================================================================================="
	
end 
	
					